from AutoRPE.UtilsRPE.Functions import load_vault, store_variable_list, load_variable_list


if __name__ == "__main__":
    # Getting Command line options
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option("-v", "--vault", dest="vault_path", default=None, metavar="FILE")
    parser.add_option("-i", "--input-list", dest="path_input_list", default=None, metavar="FILE")
    parser.add_option("-o", "--output-list", dest="path_to_output_list", default="list_of_additional_var.txt", metavar="FILE")

    (options, args) = parser.parse_args()
    vault_path = options.vault_path
    path_to_input_list = options.path_input_list
    path_to_output_list = options.path_to_output_list

    if path_to_input_list is None and vault_path is None:
       print("\nOne of the arguments -s/--input-source or -v/--vault is mandatory\n")
       parser.print_help()
       exit(1)

    print("Creates a list of additional variables that needs change in precision to be ble to compile")
    
    # In case no vault has been provided it will create it from the sources in the input sources folder
    # path_to_preprocessed_sources = "./tmp_processedsources/"
    vault = load_vault(vault_path)
    id_in_list = load_variable_list(path_to_input_list)
    list_of_additional_var_id = []
    for _id in id_in_list:
        var = vault.get_variable_by_id(_id)
        for additional_var in var.same_as:
            if additional_var.id:
                list_of_additional_var_id.append(additional_var.id)




    all_variables = list(set(list_of_additional_var_id+id_in_list))
    store_variable_list(all_variables, path_to_output_list, vault)
