from AutoRPE.UtilsRPE.Functions import load_vault
import math
import sys
from os.path import realpath

ceil = math.ceil


def set_precision_to(value, _vault):
    for variable in _vault.variables:
        if variable.mutable:
            variable.precision = value


if __name__ == "__main__":
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option("-v", "--vault", dest="vault", default=None, metavar="FILE",
                      help="Path to the vault database")
    parser.add_option("-o", "--output-namelist", dest="output", default="namelist_precisions", metavar="FILE",
                      help="Filename for the output namelist. Default=namelist_precisions")

    (options, args) = parser.parse_args()
    vault_path = options.vault
    output_filename = options.output

    if vault_path is None:
        print("\nArgument -v/--vault is mandatory\n")
        parser.print_help()
        exit(1)


    vault = load_vault(vault_path)

    if not vault:
        print("Not able to load %s !\nUnable to create namelist!" % vault_path)
        exit(1)

    variables = sorted([var for var in vault.variables if var.mutable], key=lambda x: x.id)

    set_precision_to(52, vault)

    vault.generate_namelist_precisions(filename=output_filename, exclude_double_precision=False)
