from AutoRPE.UtilsRPE.Functions import load_vault, store_variable_list, load_variable_list
from AutoRPE.UtilsRPE.TrackDependency import track_dependencies, propagate_dependencies


if __name__ == "__main__":
    # Getting Command line options
    from optparse import OptionParser

    parser = OptionParser()
    parser.add_option("-v", "--vault", dest="vault", default=None, metavar="FILE")
    parser.add_option("-s", "--input-source", dest="input_source", default="../ModelSources/Input", metavar="FILE")
    parser.add_option("-i", "--input-list", dest="path_input_list", default="./list_for_G.txt", metavar="FILE")
    parser.add_option("-p", "--preprocessed-source", dest="path_to_preprocessed_sources",
                      default="../ModelSources/Processed", metavar="FILE")
    parser.add_option("-o", "--output-list", dest="path_to_output_list", default="list_of_additional_var.txt",
                      metavar="FILE")

    (options, args) = parser.parse_args()
    vault_path = options.vault
    path_to_input_sources = options.input_source
    path_to_input_list = options.path_input_list
    path_to_preprocessed_sources = options.path_to_preprocessed_sources
    path_to_output_list = options.path_to_output_list

    if vault_path is None:
        if path_to_input_sources is None:
            print("\nOne of the arguments -s/--input-source or -v/--vault is mandatory\n")
            parser.print_help()
            exit(1)
    if path_to_preprocessed_sources is None:
        print("\nThe arguments -p/ --preprocessed-source is mandatory\n")
        parser.print_help()
        exit(1)


    print("Creating a database from sources from path_to_preprocessed_sourcesd in:\n   %s\n\n" % path_to_input_sources)

    if vault_path is None:
        from AutoRPE.Scrips import ImplementRPEtoSource
        # execute ImplementRPEtoSource
        raise ValueError("this case is not implemented yet")

    else:
        vault = load_vault(vault_path)

    try:
        same_as = vault.variables[0].same_as
    except AttributeError:
        for var in vault.variables:
            var.same_as = []

    # Here tracks variables dependencies
    track_dependencies(path_to_preprocessed_sources, vault)
    propagate_dependencies(vault)

    id_in_list = load_variable_list(path_to_input_list)
    list_of_additional_var_id = []
    for id in id_in_list:
        var = vault.get_variable_by_id(id)
        for additional_var in var.same_as:
            if additional_var.id:
                list_of_additional_var_id.append(additional_var.id)

    store_variable_list(list_of_additional_var_id, 'equivalent_ids', vault)