#!/bin/bash
###############################################################################
#                             SBATCH HEADER TEMPLATE
###############################################################################
#SBATCH --ntasks 48
#SBATCH -J %JOBNAME%
#SBATCH --output %LOGDIR%/log_%j.out
#SBATCH --error  %LOGDIR%/log_%j.err
#SBATCH --time 00:20:00
##SBATCH --qos=debug

set -xuve

JOB_ID=${SLURM_JOB_ID:-$LSB_JOBID}

RUN_dir=%RUNDIR%


# =============================================================================
# *** END of User configuration
# =============================================================================

set -xuve

if [[ -d $RUN_dir ]]; then
   rm -rf $RUN_dir
fi

mkdir -p $RUN_dir

cd $RUN_dir

echo ${JOB_ID} > job_id.txt

SCRATCH=/gpfs/scratch/pr1egi00/pr1egi23/

EXPID=a1b5
INIDATA_PATH=${SCRATCH}/MP-Repo/${EXPID}/inidata/

namelist=%NAMELIST_PATH%

ln -sf ${INIDATA_PATH}/* .


if [ ! -f $namelist ] ;  then
     echo "namelist does not exist fort this case"
else
   cp $namelist namelist_precisions

   ls -lrt *

   # SIMULATION::

   set +xuve
   source mn4.env
   set -xuve



   time mpirun -n 48 ./nemo.exe


   rm -f ORCA2_????????_restart_????.nc
   rm -f mesh_mask_????.nc
fi





set +xuve

module purge
module load intel mkl python netcdf
evaluate_script=/gpfs/scratch/pr1egi00/pr1egi23/MP-Repo/RefinementNEMO4/single_file.py
python ${evaluate_script} ORCA2_1d_*_grid_T.nc > accuracy.txt

set -xuve

var=$(cat accuracy.txt)

[[ -z $var ]] && printf "thetao 1000\nso 1000\nheatc 1000\nsaltc 1000\n" > accuracy.txt


exit 0
