#!/bin/bash
###############################################################################
#                             SBATCH HEADER TEMPLATE
###############################################################################
#SBATCH --ntasks 96
#SBATCH -J %JOBNAME%
#SBATCH --output %LOGDIR%/log_%j.out
#SBATCH --error  %LOGDIR%/log_%j.err
#SBATCH --time 00:20:00
##SBATCH --qos=debug

set -xuve

JOB_ID=${SLURM_JOB_ID:-$LSB_JOBID}


# The rundir path will be replaced by the scheduler
RUN_dir=%RUNDIR%


# =============================================================================
# *** END of User configuration
# =============================================================================

set -xuve

if [[ -d $RUN_dir ]]; then
   rm -rf $RUN_dir
fi

mkdir -p $RUN_dir

cd $RUN_dir

echo ${JOB_ID} > job_id.txt




nemo_bin=nemo.exe

# Linking all files in the the inidata folder
INIDATA_PATH=
ln -sf ${INIDATA_PATH}/* .


# The namelist path will be replaced by the scheduler
namelist=%NAMELIST_PATH%
if [ ! -f $namelist ] ;  then
     echo "namelist does not exist fort this case"
else
   cp $namelist --remove-destination namelist_precisions

   ls -lrt *


######################################################
#     SIMULATION::

# Load environment
environment_file=mn4.env
set +xuve
source ${environment_file}
set -xuve

# Prepare initial conditions
# Create restart with perturbations
time mpirun -n 96 ./${nemo_bin}

# Remove restarts
   rm -f ORCA2_????????_restart_????.nc
   rm -f mesh_mask_????.nc
fi


printf "var 0\n" > accuracy.txt


set +xuve
exit 0
