from AutoRPE.UtilsRPE.BasicFunctions import remove_literals
from AutoRPE.UtilsRPE.CurrentBlock import CurrentBlock
from AutoRPE.UtilsRPE.BasicStructures import Procedure
from AutoRPE.UtilsRPE.CallManager import find_called_function, find_call_arguments, calls_to_procedure
from AutoRPE.UtilsRPE.Getter import get_type_of_contents
from AutoRPE.UtilsRPE.Inserter import add_rpe_to_argument

import AutoRPE.UtilsRPE.VariablePrecision as VariablePrecision

import re


class DerivedType(Procedure):
    def __init__(self, _name, module, _extended_structure=None, ):
        super(DerivedType, self).__init__(_name, module)
        self.extended_structure = _extended_structure
        self.extension = None

    def get_variable(self, item):
        for variable in self.variables:
            if variable.name.lower() == item.lower():
                return variable


def in_which_type_definition(_line, type_def):
    _line = _line.strip().lower()
    _line = remove_literals(_line)
    _pattern_type = "^ *type[^(].*::(.*)"
    _pattern_type_alt = "^ *type[^(](.*)"
    _pattern_type_end = "^ *end *type"

    # We are changing block
    if type_def is None:
        m = re.match(_pattern_type, _line, re.I)
        if m:
            type_name = m.group(1).strip()
            return type_name
        n = re.match(_pattern_type_alt, _line, re.I)
        if n:
            type_name = n.group(1).strip()
            return type_name
    else:
        m = re.search(_pattern_type_end, _line, re.I)
        if m:
            return None
    return type_def


def fix_type_conversion(implement_rpe_file):
    current_block = CurrentBlock(implement_rpe_file.module.main())
    for line_index, line in enumerate(implement_rpe_file.lines):
        function_calls = calls_to_procedure(line, procedure_type=DerivedType, vault=implement_rpe_file.source_info)
        if not function_calls:
            # If not, look if the code is entering or exiting a routine block
            current_block = current_block.in_which_block(line, vault=implement_rpe_file.source_info)
        else:
            # Fix function calls (line_index
            temporal_line = line
            for call in function_calls:
                called_function = find_called_function(call)
                called_arguments = find_call_arguments(call)
                if not called_arguments:
                    continue

                procedure = implement_rpe_file.source_info.get_procedure_by_name(called_function)
                if isinstance(procedure, DerivedType):
                    pass
                else:
                    raise TypeError("The %s procedure does not have the DerivedType type" % procedure.name)

                temporal_call = call
                for argument_index, argument in enumerate(called_arguments):
                    # TODO: Probably should find a better solution, the code should not identify an array as a
                    # Todo: ... function even if the name coincides. sbcice_lim and lib_fortran fail without it
                    if argument == ":":
                        continue
                    argument_type = get_type_of_contents(argument, routine=current_block.routine,
                                                     vault=implement_rpe_file.source_info)
                    dummy_argument = procedure.get_variable_by_position(argument_index)
                    if not dummy_argument:
                        raise AssertionError("Variable not found in position: %i" % argument_index)
                    if argument_type == dummy_argument.type:
                        continue
                    elif argument_type in VariablePrecision.real_types and dummy_argument.type == "rpe_var":
                        temporal_call = add_rpe_to_argument(temporal_call, argument_index)
                    else:
                        raise AssertionError("Types do not coincide and the case is not considered %s %s" % (
                            argument_type, dummy_argument.type))
                temporal_line = temporal_line.replace(call, temporal_call)
            implement_rpe_file.lines[line_index] = temporal_line
    implement_rpe_file.rebuild_text()