# define Python user-defined exceptions
class Error(Exception):
    """Base class for other exceptions"""
    pass


class ValueTooSmallError(Error):
    """Raised when the input value is too small"""
    pass


class ValueTooLargeError(Error):
    """Raised when the input value is too large"""
    pass


class LineNotFound(Error):
    """Line you were searching for in file could not be found"""
    pass


class PointerTarged(Error):
    """Pointer and corresponding target types do not coincide"""
    pass


class ProcedureNotFound(Error):
    """The procedure you were searching for in vault could not be found"""
    pass


class DimensionNotFound(Error):
    """The dimension of the argument you were searching for in vault could not be found"""
    pass


class HardcodedRealWithoutPrecision(Error):
    """The hardcoded real does not have precision specification"""


class MemberNotFound(Error):
    """Structure member not found"""


class DerivedTypeNotFound(Error):
    """Derived type not found"""


class VariableNotFound(Error):
    """Variable not found in vault"""


class IsNotAnArray(Error):
    """Passed string is not an array"""


class DuplicatedObject(Error):
    """Found duplicated object, this should not happen. Check is needed """
