# Stores pattern reused along the code

# Capures a real number with precision specification: 0.5_dp / 0_sp
real_number_with_precision = r"^[0-9\.]*_\w+$"
# Pattern for numbers in exponential form, or numbers with double precision exponent
number_exp_DPE_notation = r'\s*\d+\.?\d*[e|d][+|-]*\d+[\w]*'


#### ARRAY
# Matches simple array, and sliced array
array = r"\w+\s*\(\s*[\w,:\d\s+\-\*=]+\s*\)"
# Array of custom type with a member following
array_with_member = array + r"[%\w]*"
# Array if custom type with an array member following
array_with_array_member = array + r"[%\w]+\(\s*[\w,:\d]+\s*\)"

# Matches with the (/old, style, vec /) or the new [array, style]
hardcoded_array = r"(\(\/|\[)\s*[\w\s,%.()\+\-=*]*\s*(\/\)|\])"


#### DECLARATION
# Captures simple types declaration
simple_type_declaration = "^ *type[^()]*[ \t](\w+) *$"
# Captures just types declaration with extended the attribute
extended_type_declaration = "^ *type\s*,(\s*public\s*,|)\s*extends *\(\s*(\w*) *\) *:: * (\w*)"
# Captures type with possible public and extended attributes
general_type_declaration = '^ *type\s*(,|)\s*(public\s*::|public|)\s*(,|)\s*(extends\((\w*)\)\s*::|) * (\w*)'
# Captures end of groups
end_type_statement = "^ *END TYPE"

# POINTER

# Captures when a pointer is assigned on a line and gives back
# - group 0 => eventual ptr attributes
# - group 2 => ptr
# - group 3 => target
pointers_assignation = "(.*::|)\s*(.*)=>\s*(.*)"